%%%%%%%%%%%%%%%%%%%% Four layers prediction using bDBN without protein-protein interaction %%%%%%%%%%%%%%%%%%%%
clear all
close all

origindata = csvread('human.rat.protein.234.csv',1,1);
save('origindata.mat','origindata')
rat.data = csvread('rat.protein.test.78.csv',1,1);
[numcasestest numdimstest] = size(rat.data);
count = 0;

%the number of layers here is based on the best model from the
%cross-validation test
firstlayer = 35; secondlayer = 30; thirdlayer = 30; forthlayer = 20;            
count=count+1;
fprintf(1,'count is %3i \n',count); 
NumOfIteration = 5;
outputdata = zeros(numcasestest,numdimstest,NumOfIteration);

   
for iteration = 1:NumOfIteration, 
    digitdata=origindata;
    save('digitdata.mat','digitdata')
    [numofsample,numofgene]=size(digitdata);

    numhid = firstlayer;numpen = secondlayer;numpen2 = thirdlayer;numopen = forthlayer;

    maxepoch=200;
    makebatches;
    [numcases numdims numbatches]=size(batchdata);
    
    %first layer
    restart=1;
    rbm;
    hidrecbiases=hidbiases; 
    save mnistvh vishid hidrecbiases visbiases;
    
    %second layer
    fprintf(1,'\nPretraining Layer 2 with RBM: %d-%d \n',numhid,numpen);
    batchdata=batchposhidprobs;
    numhid=numpen;
    restart=1;
    rbm;
    hidpen=vishid; penrecbiases=hidbiases; hidgenbiases=visbiases;
    save mnisthp hidpen penrecbiases hidgenbiases;
   
    %third layer
    fprintf(1,'\nPretraining Layer 3 with RBM: %d-%d \n',numpen,numpen2);
    batchdata=batchposhidprobs;
    numhid=numpen2;
    restart=1;
    rbm;
    hidpen2=vishid; penrecbiases2=hidbiases; hidgenbiases2=visbiases;
    save mnisthp2 hidpen2 penrecbiases2 hidgenbiases2;
    
    %forth layer
    fprintf(1,'\nPretraining Layer 4 with RBM: %d-%d \n',numpen2,numopen);
    batchdata=batchposhidprobs;
    numhid=numopen; 
    restart=1;
    rbmhidlinear;
    hidtop=vishid; toprecbiases=hidbiases; topgenbiases=visbiases;
    save mnistpo hidtop toprecbiases topgenbiases;
    
    backprop;
    
    %%%%%%%%%%%%%%%%%Using the model learnt above to do the prediction%%%%%%%%%%%%%
    %the index of human protein is 1:16 and the index of rat protein is 17:33
    N=numcasestest;
    rat.data = [rat.data ones(N,1)];
    w1probs = 1./(1 + exp(-rat.data*2*w1(17:33,:))); w1probs = [w1probs  ones(N,1)];
    %fprintf(1,'w1probs %d\r',w1probs(1,1));
    w2probs = 1./(1 + exp(-w1probs*w2)); w2probs = [w2probs ones(N,1)];
    w3probs = 1./(1 + exp(-w2probs*w3)); w3probs = [w3probs  ones(N,1)];
    w4probs = w3probs*w4; w4probs = [w4probs  ones(N,1)];
    w5probs = 1./(1 + exp(-w4probs*w5)); w5probs = [w5probs  ones(N,1)];
    w6probs = 1./(1 + exp(-w5probs*w6)); w6probs = [w6probs  ones(N,1)];
    w7probs = 1./(1 + exp(-w6probs*w7)); w7probs = [w7probs  ones(N,1)];
    dataout = 1./(1 + exp(-w7probs*w8(:,1:16)));
    %save the predited result for each iteration
    outputdata(:,:,iteration)=dataout;
end
csvwrite(['challenge2.4layers.final.prediction.withoutproteininteraction.',num2str(firstlayer),'.',num2str(secondlayer),'.',num2str(thirdlayer),'.',num2str(forthlayer),'.csv'],mean(outputdata,3))           
            