% The code below was modified based on the code provided by Geoff Hinton 
% and Ruslan Salakhutdinov (Science paper: Reducing the Dimensionality
% Of Data with Neural Networks)

load digitdata.mat

totnum=size(digitdata,1);
fprintf(1, 'Size of the training dataset= %5d \n', totnum);

rand('state',0); %so we know the permutation of the training data
randomorder=randperm(totnum);

numbatches=1;
numdims  =  size(digitdata,2);
batchsize  =  size(digitdata,1);
batchdata = zeros(batchsize, numdims, numbatches);

for b=1:numbatches
  batchdata(:,:,b) = digitdata(randomorder(1+(b-1)*batchsize:b*batchsize), :);
end;
clear digitdata;

%%% Reset random seeds 
rand('state',sum(100*clock)); 
randn('state',sum(100*clock)); 



